/* @mode.c - change a chmod type mode string to a Mode
 */
#include <stdio.h>
#define __USE_BSD
#include <sys/stat.h>
#include "gen.h"

Mode whowhat(Mode currmode, int who, int how, int what);

/* @buftomode
 */
Mode buftomode(char *buf, Mode currmode)
	{
	Mode rtn = 0; 
	int who = 0, how = 0, what = 0;
	int count;
	Bool isdir;

#	ifdef DEB
	errfmt("buftomode: '%s'\n", buf);
#	endif
	isdir = S_ISDIR(currmode);
	if (isdigit(buf[0]))
		{
		int mode;

		sscanf(buf, "%o", &mode);
		return (Mode)mode;
		}
	for (count = 0; buf[count]; count++)
		{
		switch (buf[count])
			{
		case 'u':
			who |= (0700 | S_ISUID | S_ISVTX);
			break;
		case 'g':
			who |= (0070 | S_ISGID | S_ISVTX);
			break;
		case 'o':
			who |= 0007;
			break;
		case '+':
		case '-':
		case '=':
			how = buf[count];
			break;
		case 'r':
			what |= 0444;
			break;
		case 'w':
			what |= 0222;
			break;
		case 'x':
			what |= 0111;
			break;
		case 'X':
			if (isdir || (currmode & 0111))
				what |= 0111;
			break;
		case 's':
			what |= (S_ISUID | S_ISGID);
			break;
#		ifdef S_ISVTX
		case 't':
			what |= S_ISVTX;
			break;
#		endif
		case ',':
			currmode = whowhat(currmode, who, how, what);
			who = how = what = 0;
			break;
		default:
			return -1;
			}
		}
	currmode = whowhat(currmode, who, how, what);
#	ifdef DEB
	errfmt("buftomode:end\n");
#	endif
	return currmode;
	}

Mode whowhat(Mode currmode, int who, int how, int what)
	{
	if (who == 0)
		who = (0777 | (S_ISUID | S_ISGID) | S_ISVTX );
	switch (how)
		{
	case '+':
		currmode |= (who & what);
		break;
	case '-':
		currmode &= ~(who & what);
		break;
	case '=':
		currmode = ((currmode & ~who) | (who & what));
		break;
		}
	return currmode;
	}
