#
# make rules for the vfs system
#

# option settings

#OTHER_DIR:= other

include build.mk

# library source modules

SRC = ${shell cat ${LIST}}

# the names of the library source files
FULL_SRC:= ${addsuffix .c, ${SRC}}
# the vfs library objects
FULL_OBJS:= ${addsuffix .o, ${addprefix ${OBJ_DIR}/, ${SRC}}}

NAME:=${strip ${notdir ${SRC_DIR}}}
# the vfs libraries
FULL_LIBRARY:= ${AR_DIR}/lib${NAME}${UNDERSCORE}${PREFIX}.a

# all the results
all: ${FULL_LIBRARY}

# kill any implicit rules for these files
${FULL_SRC} : ;

# build the vfs FULL_LIBRARY
${FULL_LIBRARY} : ${FULL_OBJS}
	${AR_COMMAND}

# build the library objects
${FULL_OBJS} : ${OBJ_DIR}/%.o : %.c
	${COMPILE_COMMAND}

# remove all generated files
clean :
	rm -f ${FULL_LIBRARY} ${FULL_OBJS}

print:
		@echo AR_DIR ${AR_DIR}
		@echo OBJ_DIR ${OBJ_DIR}
		@echo FULL_LIBRARY ${FULL_LIBRARY}
